#

#
# Automated Build Script for Egg to package the Mac OS X application during a release build.
#
# <!-- Copyright (c) 2015 Tim Beaudet - All Rights Reserved -->
#---------------------------------------------------------------------------------------------------------------------#

export toSlnDir=""
export toRunDir="../../run/"

if [ -z ${buildType} ]; then
	export buildType="release"
	echo Build type was undefined, defining as: $buildType
fi

if [ -z ${exePostfix} ]; then
	export exePostfix=""
	echo exePostfix was undefined, defining as: $exePostfix
fi

#If the Mac OS X application package already exists, first delete it before recreating.
if [ -d "${toRunDir}../Egg.app" ]; then
  rm -r "${toRunDir}../Egg.app"
fi

#Make the directory structure of the Mac OS X application package, then copy executable and data into package.
mkdir -p "${toRunDir}../Egg.app"
mkdir -p "${toRunDir}../Egg.app/Contents"
mkdir -p "${toRunDir}../Egg.app/Contents/MacOS"
mkdir -p "${toRunDir}../Egg.app/Contents/Resources"
mkdir -p "${toRunDir}../Egg.app/Contents/Resources/data"
cp "../macosx/${buildType}/egg.app/Contents/MacOS/egg" "${toRunDir}../Egg.app/Contents/MacOS/Egg"
cp -r "${toRunDir}data/" "${toRunDir}../Egg.app/Contents/Resources/data/"

#Copy the executable into the run directory, if using source-control this could be committed and shared with team.
if [ -d "${toRunDir}egg${exePostfix}" ]; then
	rm "${toRunDir}egg${exePostfix}"
fi

cp "../macosx/${buildType}/egg.app/Contents/MacOS/egg" "${toRunDir}egg${exePostfix}"
