///
/// @file
/// @details An entity within the Egg project.
///
/// <!-- Copyright (c) 2015 Tim Beaudet - All Rights Reserved -->
///-----------------------------------------------------------------------------------------------------------------///

#ifndef _Egg_BasketEntity_h_
#define _Egg_BasketEntity_h_

#include "egg.h"

namespace Egg
{

	class BasketEntity : public tbGame::Entity
	{
	public:
		BasketEntity(void);
		virtual ~BasketEntity(void);

	protected:
		virtual void OnAdded(void) override;
		virtual void OnRemoved(void) override;
		virtual void OnSimulate(void) override;
		virtual void OnUpdate(const float deltaTime) override;
		virtual void OnRender(void) const override;
		virtual void OnCollideWith(tbGame::Entity& otherEntity) override;

	private:
		tbGraphics::Sprite mSprite;
	};

}; /* namespace Egg */

#endif /* _Egg_BasketEntity_h_ */
