///
/// @file
/// @details Entry point of the Egg project.
///
/// <!-- Copyright (c) 2015 Tim Beaudet - All Rights Reserved -->
///-----------------------------------------------------------------------------------------------------------------///

#include "egg.h"
#include "scene_manager.h"

//--------------------------------------------------------------------------------------------------------------------//

int real_main(int argumentCount, const char* argumentValues[])
{
	tbGame::GameApplication gameApplication;
	gameApplication.SetWindowTitle(tb_string("Egg"));

	tbGraphics::theSpriteManager.LoadSpriteSheetFromFile("concept_art", "data/concept_kit/concept_art_sheet.json");
	tbAudio::theAudioManager.LoadEventTable("concept_audio", "data/concept_kit/concept_audio_events.json");
	tbAudio::theAudioManager.LoadEventTable("audio_events", "data/audio/audio_events.json");

	Egg::SceneManager::CreateSceneManager();
	gameApplication.RunGame(Egg::SceneManager::GetScene(Egg::kGameplayScene));
	Egg::SceneManager::DestroySceneManager();

	return 0;
}

//--------------------------------------------------------------------------------------------------------------------//

int main(const int argumentCount, const char* argumentValues[])
{
	tb_log_open("debug_log.txt", true);
	tb_log("Started Game: Egg\n");

	int returnCode = tb_debug_project_entry_point_with(real_main, argumentCount, argumentValues);

	tb_log("Clean shutdown.\n");
	tb_log_close();
	return returnCode;
}

//--------------------------------------------------------------------------------------------------------------------//
