///
/// @file
/// @details A way to store and set results, like current/best score for the Egg project.
///
/// <!-- Copyright (c) 2015 Tim Beaudet - All Rights Reserved -->
///-----------------------------------------------------------------------------------------------------------------///

#include "game_results.h"

namespace Egg
{
	namespace GameResults
	{

		uint32_t theCurrentScore(0);
		uint32_t theBestScore(0);

	}; /* namespace GameResults */
}; /* namespace Egg */

//--------------------------------------------------------------------------------------------------------------------//

void Egg::GameResults::ResetGameResults(bool includingBest)
{
	theCurrentScore = 0;

	if (true == includingBest)
	{
		ResetBestResults();
	}
}

//--------------------------------------------------------------------------------------------------------------------//

void Egg::GameResults::ResetBestResults(void)
{
	theBestScore = 0;
}

//--------------------------------------------------------------------------------------------------------------------//

uint32_t Egg::GameResults::GetCurrentScore(void)
{
	return theCurrentScore;
}

//--------------------------------------------------------------------------------------------------------------------//

uint32_t Egg::GameResults::GetBestScore(void)
{
	return theBestScore;
}

//--------------------------------------------------------------------------------------------------------------------//

void Egg::GameResults::IncrementCurrentScore(const uint32_t& increaseAmount)
{
	theCurrentScore += increaseAmount;
	if (theCurrentScore > theBestScore)
	{
		theBestScore = theCurrentScore;
	}
}

//--------------------------------------------------------------------------------------------------------------------//
