///
/// @file
/// @details A way to store and set results, like current/best score for the Egg project.
///
/// <!-- Copyright (c) 2015 Tim Beaudet - All Rights Reserved -->
///-----------------------------------------------------------------------------------------------------------------///

#ifndef _Egg_GameResults_h_
#define _Egg_GameResults_h_

#include "egg.h"

#include <stdint.h>

namespace Egg
{

	namespace GameResults
	{
		void ResetGameResults(bool includingBest);
		void ResetBestResults(void);

		uint32_t GetCurrentScore(void);
		uint32_t GetBestScore(void);

		void IncrementCurrentScore(const uint32_t& increaseAmount = 1);
	};

}; /* namespace Egg */

#endif /* _Egg_GameResults_h_ */
