///
/// @file
/// @details This scene is the gameplay scene for the Egg project.
///
/// <!-- Copyright (c) 2015 Tim Beaudet - All Rights Reserved -->
///-----------------------------------------------------------------------------------------------------------------///

#ifndef _Egg_GameplayScene_h_
#define _Egg_GameplayScene_h_

#include "egg.h"

namespace Egg
{

	class GameplayScene : public tbGame::GameScene
	{
	public:
		GameplayScene(void);
		virtual ~GameplayScene(void);

		virtual void OnSimulate(void) override;
		virtual void OnUpdate(const float deltaTime) override;
		virtual void OnRender(void) const override;
		virtual void OnOpen(void) override;
		virtual void OnClose(void) override;

		static void MarkResetGame(void);
	protected:
		void ResetGame(void);

	private:
		tbGame::GameTimer mEggDropTimer;
		int mNextEggDropTime;
	};

}; /* namespace Egg */

#endif /* _Egg_GameplayScene_h_ */
