///
/// @file
/// @details An entity within the Egg project.
///
/// <!-- Copyright (c) 2015 Tim Beaudet - All Rights Reserved -->
///-----------------------------------------------------------------------------------------------------------------///

#include "score_display.h"
#include "game_results.h"

//--------------------------------------------------------------------------------------------------------------------//

Egg::ScoreDisplay::ScoreDisplay(void) :
	tbGame::Entity("ScoreDisplay")
{
	mScoreText.SetScroll(0.0f);
	AddGraphic(mScoreText);

	mBestScoreText.SetScroll(0.0f);
	AddGraphic(mBestScoreText);
}

//--------------------------------------------------------------------------------------------------------------------//

Egg::ScoreDisplay::~ScoreDisplay(void)
{
}

//--------------------------------------------------------------------------------------------------------------------//

void Egg::ScoreDisplay::OnAdded(void)
{
	tbGame::Entity::OnAdded();
}

//--------------------------------------------------------------------------------------------------------------------//

void Egg::ScoreDisplay::OnRemoved(void)
{
	tbGame::Entity::OnRemoved();
}

//--------------------------------------------------------------------------------------------------------------------//

void Egg::ScoreDisplay::OnSimulate(void)
{
	tbGame::Entity::OnSimulate();
}

//--------------------------------------------------------------------------------------------------------------------//

void Egg::ScoreDisplay::OnUpdate(const float deltaTime)
{
	tbGame::Entity::OnUpdate(deltaTime);

	mScoreText.SetText("Score: " + tbCore::ToString(Egg::GameResults::GetCurrentScore()));
	mScoreText.SetPosition(20.0f, 20.0f);

	mBestScoreText.SetText("Best: " + tbCore::ToString(Egg::GameResults::GetBestScore()));
	mBestScoreText.SetPosition(tbGraphics::ScreenWidth() - (20.0f + mBestScoreText.GetWidth()), 20.0f);
}

//--------------------------------------------------------------------------------------------------------------------//

void Egg::ScoreDisplay::OnRender(void) const
{
	tbGame::Entity::OnRender();
}

//--------------------------------------------------------------------------------------------------------------------//

void Egg::ScoreDisplay::OnCollideWith(tbGame::Entity& otherEntity)
{
	tbGame::Entity::OnCollideWith(otherEntity);
}

//--------------------------------------------------------------------------------------------------------------------//
